# Animated Texture Plugin for Unreal Engine 5

----
This plugin allows you to import animated pictures into your Unreal Engine 5 project as a new AnimatedTexture asset type.
- [x] Support .GIF files
- [x] Support .Webp files

![DEMO](./Docs/images/demo.png)

## Features

- [x] Import Animated GIF/Webp as a Texture, supports animation, transparency, interlace, etc
- [x] Editing in default Texture Editor
- [x] Supports UMG Image widget, Material and Material Instance
- [x] Animation playback APIs
- [ ] Runtime load GIF/Webp file from disk or download from web

## Compatibility

The plugin should work on all platforms the Unreal Engine 5 supports, but it has not been tested on every platform.
- [x] Windows 64
- [ ] MacOS

## Screenshots

![Material DEMO](./Docs/images/mtl.png)

![UMG DEMO](./Docs/images/umg.png)

![Playback API DEMO](./Docs/images/api.png)


